Index: /palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_module.f90	(revision 4105)
+++ /palm/trunk/SOURCE/data_output_module.f90	(revision 4106)
@@ -1857,126 +1938,82 @@
                CALL binary_write_attribute( file_id=file_id, var_id=var_id,          &
                        att_name=attribute%name, att_value_char=attribute%value_char, &
-                       return_value=return_value )
+                       return_value=output_return_value )
 
             CASE( 'int8' )
                CALL binary_write_attribute( file_id=file_id, var_id=var_id,          &
                        att_name=attribute%name, att_value_int8=attribute%value_int8, &
-                       return_value=return_value )
+                       return_value=output_return_value )
 
             CASE( 'int16' )
                CALL binary_write_attribute( file_id=file_id, var_id=var_id,            &
                        att_name=attribute%name, att_value_int16=attribute%value_int16, &
-                       return_value=return_value )
+                       return_value=output_return_value )
 
             CASE( 'int32' )
                CALL binary_write_attribute( file_id=file_id, var_id=var_id,            &
                        att_name=attribute%name, att_value_int32=attribute%value_int32, &
-                       return_value=return_value )
+                       return_value=output_return_value )
 
             CASE( 'real32' )
                CALL binary_write_attribute( file_id=file_id, var_id=var_id,              &
                        att_name=attribute%name, att_value_real32=attribute%value_real32, &
-                       return_value=return_value )
+                       return_value=output_return_value )
 
             CASE( 'real64' )
                CALL binary_write_attribute( file_id=file_id, var_id=var_id,              &
                        att_name=attribute%name, att_value_real64=attribute%value_real64, &
-                       return_value=return_value )
+                       return_value=output_return_value )
 
             CASE DEFAULT
                return_value = 1
-               CALL internal_message( 'error',                                          &
-                                      routine_name //                                   &
-                                      ': attribute "' // TRIM( attribute%name ) //      &
-                                      '": data type "'// TRIM( attribute%data_type ) // &
-                                      '" not supported for file format "binary".' )
+               CALL internal_message( 'error', routine_name //                     &
+                                      ': file format "' // TRIM( file_format ) //  &
+                                      '" does not support attribute data type "'// &
+                                      TRIM( attribute%data_type ) //               &
+                                      '" ' // TRIM( temp_string ) )
 
          END SELECT
 
-      CASE ( 'netcdf4-serial' )
+      CASE ( 'netcdf4-parallel', 'netcdf4-serial' )
 
          SELECT CASE ( TRIM( attribute%data_type ) )
 
             CASE( 'char' )
-               CALL netcdf4_serial_write_attribute( file_id=file_id, var_id=var_id,  &
+               CALL netcdf4_write_attribute( file_id=file_id, var_id=var_id,  &
                        att_name=attribute%name, att_value_char=attribute%value_char, &
-                       return_value=return_value )
+                       return_value=output_return_value )
 
             CASE( 'int8' )
-               CALL netcdf4_serial_write_attribute( file_id=file_id, var_id=var_id,  &
+               CALL netcdf4_write_attribute( file_id=file_id, var_id=var_id,  &
                        att_name=attribute%name, att_value_int8=attribute%value_int8, &
-                       return_value=return_value )
+                       return_value=output_return_value )
 
             CASE( 'int16' )
-               CALL netcdf4_serial_write_attribute( file_id=file_id, var_id=var_id,    &
+               CALL netcdf4_write_attribute( file_id=file_id, var_id=var_id,    &
                        att_name=attribute%name, att_value_int16=attribute%value_int16, &
-                       return_value=return_value )
+                       return_value=output_return_value )
 
             CASE( 'int32' )
-               CALL netcdf4_serial_write_attribute( file_id=file_id, var_id=var_id,    &
+               CALL netcdf4_write_attribute( file_id=file_id, var_id=var_id,    &
                        att_name=attribute%name, att_value_int32=attribute%value_int32, &
-                       return_value=return_value )
+                       return_value=output_return_value )
 
             CASE( 'real32' )
-               CALL netcdf4_serial_write_attribute( file_id=file_id, var_id=var_id,      &
+               CALL netcdf4_write_attribute( file_id=file_id, var_id=var_id,      &
                        att_name=attribute%name, att_value_real32=attribute%value_real32, &
-                       return_value=return_value )
+                       return_value=output_return_value )
 
             CASE( 'real64' )
-               CALL netcdf4_serial_write_attribute( file_id=file_id, var_id=var_id,      &
+               CALL netcdf4_write_attribute( file_id=file_id, var_id=var_id,      &
                        att_name=attribute%name, att_value_real64=attribute%value_real64, &
-                       return_value=return_value )
+                       return_value=output_return_value )
 
             CASE DEFAULT
                return_value = 1
-               CALL internal_message( 'error',                                          &
-                                      routine_name //                                   &
-                                      ': attribute "' // TRIM( attribute%name ) //      &
-                                      '": data type "'// TRIM( attribute%data_type ) // &
-                                      '" not supported for file format "netcdf4-serial".' )
-
-         END SELECT
-
-      CASE ( 'netcdf4-parallel' )
-
-         SELECT CASE ( TRIM( attribute%data_type ) )
-
-            CASE( 'char' )
-               CALL netcdf4_parallel_write_attribute( file_id=file_id, var_id=var_id, &
-                       att_name=attribute%name, att_value_char=attribute%value_char,  &
-                       return_value=return_value )
-
-            CASE( 'int8' )
-               CALL netcdf4_parallel_write_attribute( file_id=file_id, var_id=var_id, &
-                       att_name=attribute%name, att_value_int8=attribute%value_int8,  &
-                       return_value=return_value )
-
-            CASE( 'int16' )
-               CALL netcdf4_parallel_write_attribute( file_id=file_id, var_id=var_id,  &
-                       att_name=attribute%name, att_value_int16=attribute%value_int16, &
-                       return_value=return_value )
-
-            CASE( 'int32' )
-               CALL netcdf4_parallel_write_attribute( file_id=file_id, var_id=var_id,  &
-                       att_name=attribute%name, att_value_int32=attribute%value_int32, &
-                       return_value=return_value )
-
-            CASE( 'real32' )
-               CALL netcdf4_parallel_write_attribute( file_id=file_id, var_id=var_id,    &
-                       att_name=attribute%name, att_value_real32=attribute%value_real32, &
-                       return_value=return_value )
-
-            CASE( 'real64' )
-               CALL netcdf4_parallel_write_attribute( file_id=file_id, var_id=var_id,    &
-                       att_name=attribute%name, att_value_real64=attribute%value_real64, &
-                       return_value=return_value )
-
-            CASE DEFAULT
-               return_value = 1
-               CALL internal_message( 'error',                                          &
-                                      routine_name //                                   &
-                                      ': attribute "' // TRIM( attribute%name ) //      &
-                                      '": data type "'// TRIM( attribute%data_type ) // &
-                                      '" not supported for file format "netcdf4-parallel".' )
+               CALL internal_message( 'error', routine_name //                     &
+                                      ': file format "' // TRIM( file_format ) //  &
+                                      '" does not support attribute data type "'// &
+                                      TRIM( attribute%data_type ) //               &
+                                      '" ' // TRIM( temp_string ) )
 
          END SELECT
@@ -1986,7 +2023,15 @@
          CALL internal_message( 'error',        &
                                 routine_name // &
-                                ': unsupported file format "' // TRIM( file_format ) // '"' )
+                                ': unsupported file format "' // TRIM( file_format ) // &
+                                '" ' // TRIM( temp_string ) )
 
    END SELECT
+   
+   IF ( output_return_value /= 0 )  THEN
+      return_value = output_return_value
+      CALL internal_message( 'error',        &
+                             routine_name // &
+                             ': error while writing attribute ' // TRIM( temp_string ) )
+   ENDIF
 
 END FUNCTION write_attribute
@@ -1997,45 +2042,55 @@
 !> Initialize dimension in file.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE init_file_dimension( file_format, file_id, dim_id, var_id,        &
-                                dim_name, dim_type, dim_length, is_init, return_value )
+SUBROUTINE init_file_dimension( file_format, file_id, file_name, dim_id, var_id, &
+                                dim_name, dim_type, dim_length, return_value )
 
    CHARACTER(LEN=*), INTENT(IN) ::  dim_name     !< name of dimension
    CHARACTER(LEN=*), INTENT(IN) ::  dim_type     !< data type of dimension
    CHARACTER(LEN=*), INTENT(IN) ::  file_format  !< file format chosen for file
+   CHARACTER(LEN=*), INTENT(IN) ::  file_name    !< name of file
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'init_file_dimension'  !< file format chosen for file
 
-   INTEGER(iwp), INTENT(OUT) ::  dim_id        !< dimension ID
-   INTEGER(iwp), INTENT(IN)  ::  dim_length    !< length of dimension
-   INTEGER(iwp), INTENT(IN)  ::  file_id       !< file ID
-   INTEGER(iwp), INTENT(OUT) ::  return_value  !< return value
-   INTEGER(iwp), INTENT(OUT) ::  var_id        !< associated variable ID
-
-   LOGICAL, INTENT(OUT) ::  is_init  !< true if dimension is initialized
-
+   INTEGER(iwp), INTENT(OUT) ::  dim_id               !< dimension ID
+   INTEGER(iwp), INTENT(IN)  ::  dim_length           !< length of dimension
+   INTEGER(iwp), INTENT(IN)  ::  file_id              !< file ID
+   INTEGER(iwp)              ::  output_return_value  !< return value of a called output routine
+   INTEGER(iwp), INTENT(OUT) ::  return_value         !< return value
+   INTEGER(iwp), INTENT(OUT) ::  var_id               !< associated variable ID
+
+
+   return_value = 0
+   output_return_value = 0
+
+   temp_string = '(file "' // TRIM( file_name ) // &
+                 '", dimension "' // TRIM( dim_name ) // '")'
 
    SELECT CASE ( TRIM( file_format ) )
 
       CASE ( 'binary' )
-         CALL binary_init_dimension( file_id, dim_id, var_id, &
-                 dim_name, dim_type, dim_length, is_init, return_value )
+         CALL binary_init_dimension( 'binary', file_id, dim_id, var_id, &
+                 dim_name, dim_type, dim_length, return_value=output_return_value )
 
       CASE ( 'netcdf4-serial' )
-         CALL netcdf4_serial_init_dimension( file_id, dim_id, var_id, &
-                 dim_name, dim_type, dim_length, is_init, return_value )
+         CALL netcdf4_init_dimension( 'serial', file_id, dim_id, var_id, &
+                 dim_name, dim_type, dim_length, return_value=output_return_value )
 
       CASE ( 'netcdf4-parallel' )
-         CALL netcdf4_parallel_init_dimension( file_id, dim_id, var_id, &
-                 dim_name, dim_type, dim_length, is_init, return_value )
+         CALL netcdf4_init_dimension( 'parallel', file_id, dim_id, var_id, &
+                 dim_name, dim_type, dim_length, return_value=output_return_value )
 
       CASE DEFAULT
          return_value = 1
-         WRITE( temp_string, * ) file_id
-         CALL internal_message( 'error', routine_name //                              &
-                                         ': file id = ' // TRIM( temp_string ) //     &
-                                         '": file format "' // TRIM( file_format ) // &
-                                         '" not supported' )
+         CALL internal_message( 'error', routine_name //                    &
+                                ': file format "' // TRIM( file_format ) // &
+                                '" not supported ' // TRIM( temp_string ) )
 
    END SELECT
+
+   IF ( output_return_value /= 0 )  THEN
+      return_value = output_return_value
+      CALL internal_message( 'error', routine_name // &
+                             ': error while defining dimension ' // TRIM( temp_string ) )
+   ENDIF
 
 END SUBROUTINE init_file_dimension
@@ -2097,9 +2152,10 @@
 !> Initialize variable.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE init_file_variable( file_format, file_id, var_id,   &
-                               var_name, var_type, var_dim_id, &
-                               is_init, is_global, return_value )
+SUBROUTINE init_file_variable( file_format, file_id, file_name,        &
+                               var_id, var_name, var_type, var_dim_id, &
+                               is_global, return_value )
 
    CHARACTER(LEN=*), INTENT(IN) ::  file_format  !< file format chosen for file
+   CHARACTER(LEN=*), INTENT(IN) ::  file_name    !< file name
    CHARACTER(LEN=*), INTENT(IN) ::  var_name     !< name of variable
    CHARACTER(LEN=*), INTENT(IN) ::  var_type     !< data type of variable
@@ -2107,35 +2163,47 @@
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'init_file_variable'  !< file format chosen for file
 
-   INTEGER(iwp), INTENT(IN)  ::  file_id       !< file ID
-   INTEGER(iwp), INTENT(OUT) ::  return_value  !< return value
-   INTEGER(iwp), INTENT(OUT) ::  var_id        !< variable ID
+   INTEGER(iwp), INTENT(IN)  ::  file_id              !< file ID
+   INTEGER(iwp)              ::  output_return_value  !< return value of a called output routine
+   INTEGER(iwp), INTENT(OUT) ::  return_value         !< return value
+   INTEGER(iwp), INTENT(OUT) ::  var_id               !< variable ID
 
    INTEGER(iwp), DIMENSION(:), INTENT(IN) ::  var_dim_id  !< list of dimension IDs used by variable
 
    LOGICAL, INTENT(IN)  ::  is_global  !< true if variable is global
-   LOGICAL, INTENT(OUT) ::  is_init    !< true if variable is initialized
-
+
+
+   return_value = 0
+   output_return_value = 0
+
+   temp_string = '(file "' // TRIM( file_name ) // &
+                 '", variable "' // TRIM( var_name ) // '")'
 
    SELECT CASE ( TRIM( file_format ) )
 
       CASE ( 'binary' )
-         CALL binary_init_variable( file_id, var_id, var_name, var_type, var_dim_id, &
-                                    is_init, is_global, return_value )
+         CALL binary_init_variable( 'binary', file_id, var_id, var_name, var_type, &
+                                    var_dim_id, is_global, return_value=output_return_value )
 
       CASE ( 'netcdf4-serial' )
-         CALL netcdf4_serial_init_variable( file_id, var_id, var_name, var_type, var_dim_id, &
-                                            is_init, is_global, return_value )
+         CALL netcdf4_init_variable( 'serial', file_id, var_id, var_name, var_type, &
+                                     var_dim_id, is_global, return_value=output_return_value )
 
       CASE ( 'netcdf4-parallel' )
-         CALL netcdf4_parallel_init_variable( file_id, var_id, var_name, var_type, var_dim_id, &
-                                              is_init, is_global, return_value )
+         CALL netcdf4_init_variable( 'parallel', file_id, var_id, var_name, var_type, &
+                                     var_dim_id, is_global, return_value=output_return_value )
 
       CASE DEFAULT
          return_value = 1
-         is_init = .FALSE.
-         CALL internal_message( 'error', routine_name // &
-                                ': unsupported file format "' // TRIM( file_format ) )
+         CALL internal_message( 'error', routine_name //                    &
+                                ': file format "' // TRIM( file_format ) // &
+                                '" not supported ' // TRIM( temp_string ) )
 
    END SELECT
+
+   IF ( output_return_value /= 0 )  THEN
+      return_value = output_return_value
+      CALL internal_message( 'error', routine_name // &
+                             ': error while defining variable ' // TRIM( temp_string ) )
+   ENDIF
 
 END SUBROUTINE init_file_variable
@@ -2148,34 +2216,43 @@
 !> @todo Do we need an MPI barrier at the end?
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE dom_init_end( file_format, file_id, return_value )
+SUBROUTINE dom_init_end( file_format, file_id, file_name, return_value )
 
    CHARACTER(LEN=*), INTENT(IN) ::  file_format  !< file format
+   CHARACTER(LEN=*), INTENT(IN) ::  file_name    !< file name
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_init_end'  !< name of routine
 
-   INTEGER(iwp), INTENT(IN)  ::  file_id       !< file id
-   INTEGER(iwp), INTENT(OUT) ::  return_value  !< return value
-
+   INTEGER(iwp), INTENT(IN)  ::  file_id              !< file id
+   INTEGER(iwp)              ::  output_return_value  !< return value of a called output routine
+   INTEGER(iwp), INTENT(OUT) ::  return_value         !< return value
+
+
+   return_value = 0
+   output_return_value = 0
+
+   temp_string = '(file "' // TRIM( file_name ) // '")'
 
    SELECT CASE ( TRIM( file_format ) )
 
       CASE ( 'binary' )
-         CALL binary_init_end( file_id, return_value )
-
-      CASE ( 'netcdf4-serial' )
-         CALL netcdf4_serial_init_end( file_id, return_value )
-
-      CASE ( 'netcdf4-parallel' )
-         CALL netcdf4_parallel_init_end( file_id, return_value )
+         CALL binary_init_end( file_id, output_return_value )
+
+      CASE ( 'netcdf4-parallel', 'netcdf4-serial' )
+         CALL netcdf4_init_end( file_id, output_return_value )
 
       CASE DEFAULT
          return_value = 1
-         WRITE( temp_string, * ) file_id
-         CALL internal_message( 'error', routine_name //                             &
-                                         ': file id = ' // TRIM( temp_string ) //    &
-                                         ': file format "' // TRIM( file_format ) // &
-                                         '" not supported' )
+         CALL internal_message( 'error', routine_name //                    &
+                                ': file format "' // TRIM( file_format ) // &
+                                '" not supported ' // TRIM( temp_string ) )
 
    END SELECT
+
+   IF ( output_return_value /= 0 )  THEN
+      return_value = output_return_value
+      CALL internal_message( 'error', routine_name // &
+                             ': error while leaving file-definition state ' // &
+                             TRIM( temp_string ) )
+   ENDIF
 
    ! CALL MPI_Barrier( MPI_COMM_WORLD, return_value )
@@ -2211,17 +2288,18 @@
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_write_var'  !< name of routine
 
-   INTEGER(iwp) ::  d             !< loop index
-   INTEGER(iwp) ::  file_id       !< file ID
-   INTEGER(iwp) ::  i             !< loop index
-   INTEGER(iwp) ::  j             !< loop index
-   INTEGER(iwp) ::  k             !< loop index
-   INTEGER(iwp) ::  return_value  !< return value
-   INTEGER(iwp) ::  var_id        !< variable ID
+   INTEGER(iwp) ::  d                    !< loop index
+   INTEGER(iwp) ::  file_id              !< file ID
+   INTEGER(iwp) ::  i                    !< loop index
+   INTEGER(iwp) ::  j                    !< loop index
+   INTEGER(iwp) ::  k                    !< loop index
+   INTEGER(iwp) ::  output_return_value  !< return value of a called output routine
+   INTEGER(iwp) ::  return_value         !< return value
+   INTEGER(iwp) ::  var_id               !< variable ID
 
    INTEGER(iwp), DIMENSION(:),   INTENT(IN)  ::  bounds_end        !< end index (upper bound) of variable at each dimension
    INTEGER(iwp), DIMENSION(:),   INTENT(IN)  ::  bounds_start      !< start index (lower bound) of variable at each dimension
    INTEGER(iwp), DIMENSION(:),   ALLOCATABLE ::  bounds_dim_start  !< start index (lower bound) of each dimension of variable
-   INTEGER(iwp), DIMENSION(:),   ALLOCATABLE ::  bounds_end_new    !< start index (upper bound) of masked variable at each dimension
-   INTEGER(iwp), DIMENSION(:),   ALLOCATABLE ::  bounds_start_new  !< start index (lower bound) of masked variable at each dimension
+   INTEGER(iwp), DIMENSION(:),   ALLOCATABLE ::  bounds_end_new    !< start index (upper bound) of msked var at each dim
+   INTEGER(iwp), DIMENSION(:),   ALLOCATABLE ::  bounds_start_new  !< start index (lower bound) of msked var at each dim
    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  masked_indices    !< dummy list holding all masked indices along a dimension
 
@@ -2330,4 +2408,7 @@
 
 
+   return_value = 0
+   output_return_value = 0
+
    CALL internal_message( 'debug', routine_name // ': write ' // TRIM( name ) // &
                                    ' into file ' // TRIM( filename ) )
@@ -2343,8 +2424,8 @@
            SIZE( bounds_end ) /= SIZE( dimension_list ) )  THEN
          return_value = 1
-         CALL internal_message( 'error', routine_name //                      &
-                                         ': variable "' // TRIM( name ) //    &
-                                         '" in file "' // TRIM( filename ) // &
-                                         '": given bounds do not match with number of dimensions' )
+         CALL internal_message( 'error', routine_name //             &
+                                ': variable "' // TRIM( name ) //    &
+                                '" in file "' // TRIM( filename ) // &
+                                '": given bounds do not match with number of dimensions' )
       ENDIF
 
